VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmAdvancedSearchResults 
   Caption         =   "SQL Result"
   ClientHeight    =   5925
   ClientLeft      =   1095
   ClientTop       =   1815
   ClientWidth     =   7890
   HelpContextID   =   730
   Icon            =   "Advanced Search Results.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5925
   ScaleWidth      =   7890
   Begin VB.PictureBox picPanel 
      Align           =   2  'Align Bottom
      Height          =   840
      Left            =   0
      ScaleHeight     =   780
      ScaleWidth      =   7830
      TabIndex        =   2
      Top             =   5085
      Width           =   7890
      Begin VB.CommandButton cmdHelp 
         Caption         =   "?"
         BeginProperty Font 
            Name            =   "Times New Roman"
            Size            =   24
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   540
         Left            =   2400
         Style           =   1  'Graphical
         TabIndex        =   7
         ToolTipText     =   "Help"
         Top             =   120
         Width           =   510
      End
      Begin VB.CommandButton cmdBack 
         Height          =   510
         Left            =   525
         Picture         =   "Advanced Search Results.frx":0442
         Style           =   1  'Graphical
         TabIndex        =   5
         ToolTipText     =   "Go to the previous page"
         Top             =   135
         Width           =   510
      End
      Begin VB.CommandButton cmdNext 
         Height          =   510
         Left            =   1470
         Picture         =   "Advanced Search Results.frx":0884
         Style           =   1  'Graphical
         TabIndex        =   4
         ToolTipText     =   "Go to the next page"
         Top             =   135
         Width           =   510
      End
      Begin VB.CommandButton cmdClose 
         Caption         =   "Close"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   510
         Left            =   3420
         Style           =   1  'Graphical
         TabIndex        =   3
         ToolTipText     =   "Exit"
         Top             =   135
         Width           =   870
      End
      Begin MSComDlg.CommonDialog dlgResults 
         Left            =   7020
         Top             =   240
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
      End
      Begin VB.Label pnlPage 
         BorderStyle     =   1  'Fixed Single
         Caption         =   "Page 1 of 1"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   285
         Left            =   5160
         TabIndex        =   6
         ToolTipText     =   "Page counter"
         Top             =   270
         Width           =   2130
      End
   End
   Begin MSFlexGridLib.MSFlexGrid grdResults 
      Height          =   3780
      Left            =   0
      TabIndex        =   0
      Top             =   45
      Width           =   7845
      _ExtentX        =   13838
      _ExtentY        =   6668
      _Version        =   393216
      WordWrap        =   -1  'True
      AllowUserResizing=   3
   End
   Begin MSComctlLib.ProgressBar pnlProgress 
      Align           =   2  'Align Bottom
      Height          =   330
      Left            =   0
      TabIndex        =   1
      Top             =   4755
      Visible         =   0   'False
      Width           =   7890
      _ExtentX        =   13917
      _ExtentY        =   582
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.Menu mnuTools 
      Caption         =   "Tools"
      Begin VB.Menu mnuTools_AdjRowHeight 
         Caption         =   "Adjust Row Height"
      End
      Begin VB.Menu mnuTools_Export 
         Caption         =   "Export Results"
         Begin VB.Menu mnuTools_Export_Generic 
            Caption         =   "Generic Format"
         End
         Begin VB.Menu mnuTools_Export_Excel 
            Caption         =   "Excel 7.0"
         End
      End
      Begin VB.Menu mnuTools_Sep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Help 
         Caption         =   "Help"
      End
      Begin VB.Menu mnuTools_Sep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Close 
         Caption         =   "Close"
      End
   End
End
Attribute VB_Name = "frmAdvancedSearchResults"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Displays the search results in pages of the length defined by lngPageLength
Option Explicit

Private Loading As Boolean

Private lngCurrentPage As Long
Private Const lngPageLength = 100
Private lngTotalPages As Long
Private strSQL As String
Private rstAdvancedSearchResult As Recordset

Private Sub cmdBack_Click()
    'Adjusts the current page variable and then call display_page to display the page
    If lngCurrentPage = 1 Then
        'Already on first page so don't adjust current page pointer
        Beep
    Else
        lngCurrentPage = lngCurrentPage - 1
        DisplayPage
    End If
    
End Sub

Private Sub DisplayPage(Optional blnHideProgress As Boolean)
    'The optional parameter allows the paging during exporting to be done without the
    'progress bar being disturbed
    
    Dim lngRowCounter As Long
    Dim lngStart As Long
    Dim strMsg As String
    
    'May take long, change mouse pointer to hour glass
    Me.MousePointer = vbHourglass
    
    'Unlikely, just a bit of defensive programming
    If rstAdvancedSearchResult.RecordCount = 0 Then
        strMsg = "Result list corrupted. Aborting!"
        MsgBox strMsg, vbCritical, "System Error"
        Unload Me
    Else
        If Not (blnHideProgress) Then LoadProgressBar
        
        'Determine the first record for the requested page and move to it
        lngStart = ((lngCurrentPage - 1) * lngPageLength)
        rstAdvancedSearchResult.MoveFirst
        rstAdvancedSearchResult.Move lngStart
        
        'Update page indicator
        pnlPage.Caption = "Page " + Str(lngCurrentPage) + " of " + Str(lngTotalPages)
        
        'Start filling grid
        For lngRowCounter = 1 To lngPageLength
            grdResults.Row = lngRowCounter
            If rstAdvancedSearchResult.EOF Then
                'Reached end of recordset so clear remaining cells
                Clear_remaining_cells lngRowCounter, blnHideProgress
                Exit For
            Else
                Enter_data_into_grid
            End If
            
            'move to next record
            rstAdvancedSearchResult.MoveNext
            
            'Update progress bar unless explicitly requested not to use it.
            If Not (blnHideProgress) Then ShowProgress lngRowCounter, lngPageLength
        Next
        
        If Not (blnHideProgress) Then UnloadProgressBar
    End If
    
    'Disable or enable the buttons if we are on the first or last page
    Enforce_previous_and_next_buttons_availability
    
    'Remember to change the mousepointer back to the default
    Me.MousePointer = vbDefault
    
    'Refresh the grid. VB will not do this automatically.
    grdResults.Refresh
    
End Sub

Private Sub Enforce_previous_and_next_buttons_availability()
    'Note that events are not mutually exclusive
    
    'If current page is first page then disable previous button
    If lngCurrentPage = 1 Then
        cmdBack.Enabled = False
    Else
        cmdBack.Enabled = True
    End If
    
    'If current page is last page then disable next button.
    If lngCurrentPage = lngTotalPages Then
        cmdNext.Enabled = False
    Else
        cmdNext.Enabled = True
    End If
    
End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 730
End Sub

Private Sub cmdNext_Click()
    'Just defensive programing
    If lngCurrentPage = lngTotalPages Then
        Beep
    Else
        lngCurrentPage = lngCurrentPage + 1
        DisplayPage
    End If
        
End Sub

Private Sub Form_Activate()
    Dim strMsg As String
    
    If Loading Then
        Loading = False
        
        'Opening the recordset may take long if the query is complex
        Me.MousePointer = vbHourglass
        Set rstAdvancedSearchResult = qryDirectSQL.OpenRecordset
        Me.MousePointer = vbDefault
        
        If rstAdvancedSearchResult.RecordCount = 0 Then
            strMsg = "The query did not return any matches."
            MsgBox strMsg, vbExclamation
            Unload Me
        Else
            Initialise
            DisplayPage
        End If
    End If
    
End Sub

Private Sub Clear_remaining_cells(StartRow As Long, blnHideProgress As Boolean)
    Dim lngRowCounter As Long
    Dim lngColCounter As Long
    
    'Clear all grid cells
    For lngRowCounter = StartRow To lngPageLength
        grdResults.Row = lngRowCounter
        For lngColCounter = 1 To (grdResults.Cols - 1)
            grdResults.Col = lngColCounter
            grdResults.Text = ""
            grdResults.CellForeColor = vbBlack
        Next lngColCounter
        If Not (blnHideProgress) Then ShowProgress lngRowCounter, lngPageLength
    Next lngRowCounter
    
End Sub

Private Sub Initialise()
    Dim lngRowCounter As Long
    Dim lngColCounter As Long
    Dim sngTotalPages As Double
    
    'Initialise paging
    rstAdvancedSearchResult.MoveLast
    sngTotalPages = (rstAdvancedSearchResult.RecordCount / lngPageLength)
    
    If IsMultipleOf(sngTotalPages, 1) Then
        lngTotalPages = sngTotalPages
    Else
        lngTotalPages = Int(sngTotalPages) + 1
    End If
    
    'Set current page to first page
    lngCurrentPage = 1
    
    'Enter headers from those returned in the recordset as field names
    grdResults.Cols = rstAdvancedSearchResult.Fields.Count + 1
    grdResults.Rows = lngPageLength + 1
    grdResults.Row = 0
    
    For lngColCounter = 1 To rstAdvancedSearchResult.Fields.Count
        grdResults.Col = lngColCounter
        grdResults.Text = rstAdvancedSearchResult.Fields(lngColCounter - 1).Name
        grdResults.ColWidth(lngColCounter) = 100 * (Len(rstAdvancedSearchResult.Fields(lngColCounter - 1).Name) + 1)
    Next
    
    'Enter Current Page record counters
    grdResults.Col = 0
    grdResults.ColAlignment(0) = flexAlignRightCenter
    grdResults.ColWidth(0) = 450
    For lngRowCounter = 1 To grdResults.Rows - 1
        grdResults.Row = lngRowCounter
        grdResults.Text = Str(lngRowCounter) + " "
    Next
    
    'Initialise alignments
    For lngColCounter = 1 To rstAdvancedSearchResult.Fields.Count
        If rstAdvancedSearchResult.Fields(lngColCounter - 1).Type = dbText Then
            grdResults.ColAlignment(lngColCounter) = flexAlignLeftTop
        Else
            grdResults.ColAlignment(lngColCounter) = flexAlignRightTop
        End If
    Next
       
    
    
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub Form_Resize()
    ResizeForm
End Sub

Private Sub ResizeForm()
    'Ensure propotionality of controls when form is loaded
    Dim lngTotalPanelHeight As Long
    
    grdResults.Left = Me.ScaleLeft
    grdResults.Width = Me.ScaleWidth
    grdResults.Top = Me.ScaleTop
    
    If pnlProgress.Visible Then
        lngTotalPanelHeight = pnlProgress.Height + picPanel.Height
    Else
        lngTotalPanelHeight = picPanel.Height
    End If
    
    If (Me.ScaleHeight - lngTotalPanelHeight) > 0 Then
        grdResults.Height = Me.ScaleHeight - lngTotalPanelHeight
    End If
    
    grdResults.Refresh
    Me.Refresh
End Sub

Private Sub Enter_data_into_grid()
    Dim lngFieldCounter As Long
    Dim dtmDateTime As Date
    Dim strDateTimeFormat
    
    'Enter current row into grid
    For lngFieldCounter = 0 To (rstAdvancedSearchResult.Fields.Count - 1)
        If Not IsNull(rstAdvancedSearchResult.Fields(lngFieldCounter).Value) Then
            grdResults.Col = lngFieldCounter + 1
            
            If rstAdvancedSearchResult.Fields(lngFieldCounter).Type = dbDate Then
                dtmDateTime = rstAdvancedSearchResult.Fields(lngFieldCounter).Value
                If IsMultipleOf(dtmDateTime, 1) Then
                    strDateTimeFormat = "dd/mm/yyyy"
                Else
                    strDateTimeFormat = "dd/mm/yyyy hh:nn"
                End If
                grdResults.Text = Format(dtmDateTime, strDateTimeFormat)
            ElseIf rstAdvancedSearchResult.Fields(lngFieldCounter).Type = dbInteger Then
                grdResults.Text = Str(rstAdvancedSearchResult.Fields(lngFieldCounter).Value) + "  "
            ElseIf rstAdvancedSearchResult.Fields(lngFieldCounter).Type = dbLong Then
                grdResults.Text = Str(rstAdvancedSearchResult.Fields(lngFieldCounter).Value) + "  "
            ElseIf rstAdvancedSearchResult.Fields(lngFieldCounter).Type = dbBoolean Then
                If rstAdvancedSearchResult.Fields(lngFieldCounter).Value = True Then
                    grdResults.Text = "Yes"
                Else
                    grdResults.Text = "No"
                End If
            ElseIf rstAdvancedSearchResult.Fields(lngFieldCounter).Type = dbCurrency Then
                grdResults.Text = CurrencyFormat(rstAdvancedSearchResult.Fields(lngFieldCounter).Value, moneyOmitSign, moneyExcludeType)
                If rstAdvancedSearchResult.Fields(lngFieldCounter).Value < 0 Then
                    grdResults.CellForeColor = vbRed
                Else
                    grdResults.CellForeColor = vbBlue
                End If
            Else
                grdResults.Text = rstAdvancedSearchResult.Fields(lngFieldCounter).Value
            End If
        End If
    Next
    
End Sub

Private Sub mnuTools_Close_Click()
    cmdClose.Value = True
End Sub

Public Function Contains_carriage_return(strText As String) As Boolean
    'Checks if a piece of text contains a carriage return
    Dim lngCharCounter As Long
    Dim strCharacter As String * 1
    
    For lngCharCounter = 1 To Len(strText)
        strCharacter = Mid(strText, lngCharCounter, 1)
        If strCharacter = vbCr Then
            Contains_carriage_return = True
            Exit For
        End If
    Next
    
End Function
Public Function ReformatMultilineText(strMultilineText As String, strSeparator As String) As String
    'Used in exporting to Comma deliminated text file.
    'Takes a piece of text and then replaces all occurances of the carriage return
    'with the supplied separator
    
    Dim strLine As String
    Dim strCurrentChar As String * 1
    Dim lngCharCounter As Long
    Dim lngLineStarts As Long
    Dim lngStringLength As Long
        
    Dim strCarriageReturn As String * 1
    Dim strLineFeed As String * 1
    
    Dim strReformated As String
    
    strCarriageReturn = vbCr
    strLineFeed = vbLf
    
    'Variables default to zero. Reinitialise them to 1 for the MID function
    lngLineStarts = 1
    lngCharCounter = 1
    lngStringLength = Len(strMultilineText)
    
    While (lngCharCounter <= lngStringLength)    'More characters still to be read
        strCurrentChar = Mid(strMultilineText, lngCharCounter, 1)
        If ((strCurrentChar = strCarriageReturn) Or (strCurrentChar = strLineFeed)) Then
            'Rip out line
            strLine = Mid(strMultilineText, lngLineStarts, lngCharCounter - lngLineStarts)
            'Copy it to the formated text
            If strReformated = "" Then
                strReformated = strLine
            Else
                strReformated = strReformated + strSeparator + strLine
            End If
            
            'Skip over any subsequent line feeds or carriage returns
            While (((strCurrentChar = strCarriageReturn) Or (strCurrentChar = strLineFeed)) And lngCharCounter <= Len(strMultilineText))
                lngCharCounter = lngCharCounter + 1
                strCurrentChar = Mid(strMultilineText, lngCharCounter, 1)
            Wend
            'Mark where next line will start
            lngLineStarts = lngCharCounter
        Else
            lngCharCounter = lngCharCounter + 1
        End If
    Wend
    
    'Check for a trailing segment i.e. between last carriage and end of line
    If lngLineStarts <= Len(strMultilineText) Then
        strLine = Mid(strMultilineText, lngLineStarts, lngStringLength - lngLineStarts + 1)
        If strReformated = "" Then
            strReformated = strLine
        Else
            strReformated = strReformated + strSeparator + strLine
        End If
    End If
            
    'Return the formated text
    ReformatMultilineText = strReformated
    
End Function

Private Sub mnuTools_Export_Excel_Click()
    'Exports the search results to an Excel Worksheet
    On Local Error GoTo errorHandler
    
    
    Dim objFileSystem As New FileSystemObject
    
    Dim objWorkbook As excel.Workbook
    Dim objWorksheet As excel.Worksheet
    Dim strColLabel As String
    
    Dim lngRowCounter As Long
    Dim lngColCounter As Long
    Dim strLine As String
    Dim strTargetFile As String
    Dim lngFileHandle As Long
    Dim strMsg As String
    
    Dim lngNumberProcessed As Long
    Dim lngJobLength As Long
    Dim lngPageCounter As Long
    Dim lngViewedPage As Long
    
    'Get filename
    With dlgResults
        .DialogTitle = "Export Results"
        .Filter = "Excel Files (*.xls)|*.xls"
        .Flags = cdlOFNPathMustExist + cdlOFNOverwritePrompt
        .FileName = ""
        .CancelError = True
        .ShowSave
    End With
    strTargetFile = dlgResults.FileName
    
    'Delete file if present
    'Above dialog will have given an overwrite prompt
    If objFileSystem.FileExists(strTargetFile) Then
        objFileSystem.DeleteFile (strTargetFile)
    End If
    
    
    Me.MousePointer = vbHourglass
    
    'Store current page being viewed
    lngViewedPage = lngCurrentPage
    
    'Calculate the number of pages to be exported
    lngJobLength = lngPageLength * lngTotalPages
    
    
    'Create Workbook
    Set objWorkbook = excel.Workbooks.Add
    Set objWorksheet = objWorkbook.Worksheets(1)
    objWorkbook.SaveAs strTargetFile
    
    'Export header
    grdResults.Row = 0
    For lngColCounter = 1 To grdResults.Cols - 1
        grdResults.Col = lngColCounter
        objWorksheet.Cells(1, lngColCounter).Value = grdResults.Text
        objWorksheet.Cells(1, lngColCounter).Font.Bold = True
    Next
    
    'initialise progress counter
    lngNumberProcessed = 0
    LoadProgressBar
    
    'Export Body
    For lngPageCounter = 1 To lngTotalPages
        'Display each page, hiding the DisplayPage, progress bar, and then export it
        lngCurrentPage = lngPageCounter
        DisplayPage (True)
        
        For lngRowCounter = 1 To grdResults.Rows - 1
            grdResults.Row = lngRowCounter
            For lngColCounter = 1 To grdResults.Cols - 1
                grdResults.Col = lngColCounter
                
                If grdResults.CellForeColor = vbRed Then
                    strLine = Str(Val(grdResults.Text) * -1)
                ElseIf grdResults.CellForeColor = vbBlue Then
                    strLine = Str(Val(grdResults.Text))
                ElseIf Contains_carriage_return(grdResults.Text) Then
                    strLine = ReformatMultilineText(grdResults.Text, Chr(10))
                    Call setWrapText(lngColCounter, objWorksheet)
                Else
                    strLine = grdResults.Text
                End If
                objWorksheet.Cells((lngPageCounter - 1) * lngPageLength + lngRowCounter + 1, lngColCounter).Value = strLine
            Next
            lngNumberProcessed = lngNumberProcessed + 1
            ShowProgress lngNumberProcessed, lngJobLength
        Next
    Next
    
    'set vertical alignment
    objWorksheet.UsedRange.VerticalAlignment = xlTop
    
    'Save and release workbook
    objWorkbook.Save
    objWorkbook.Close
    UnloadProgressBar

    'Reload page that was being viewed
    lngCurrentPage = lngViewedPage
    DisplayPage
    
    Me.MousePointer = vbDefault
    
    'Inform user of successful exportation
    strMsg = "Results successfully exported to " + strTargetFile
    MsgBox strMsg, vbInformation, "Export Results"

    
Exit Sub

errorHandler:
    UnloadProgressBar
    'Display error and abort
    If Err.Number <> cdlCancel Then
        MsgBox Err.Description, vbExclamation, "Aborting"
    End If
    Call ForceWorkbookRelease(objWorkbook)
    Me.MousePointer = vbDefault
    Exit Sub
Resume
    
End Sub

Private Sub ForceWorkbookRelease(objObject As Object)
    On Local Error Resume Next
    objObject.Save
    objObject.Close
End Sub

Private Function setWrapText(lngColNumber As Long, Worksheet As excel.Worksheet) As String
    Dim strColLabel As String
    
    'Convert the column number into an excel column label
    If 1 <= lngColNumber <= 26 Then
        strColLabel = Chr(Asc("A") + lngColNumber - 1)
    ElseIf 27 <= lngColNumber <= 26 * 25 Then
        strColLabel = Chr(Asc("A") + Int((lngColNumber - 1) / 26) - 1)
        strColLabel = strColLabel + Chr(Asc("A") + ((lngColNumber - 1) Mod 26))
    End If
    strColLabel = strColLabel + ":" + strColLabel
    
    'Change the cell formating so that it accepts multiline text
    If Worksheet.Range(strColLabel).WrapText = False Then
        Worksheet.Range(strColLabel).WrapText = True
        Worksheet.Range(strColLabel).ColumnWidth = 30
    End If
    
End Function

Private Sub mnuTools_Export_Generic_Click()
    'Exports to a standard comma deliminated text file
    
    Dim lngRowCounter As Long
    Dim lngColCounter As Long
    Dim strLine As String
    Dim strTargetFile As String
    Dim strMsg As String
    
    Dim lngNumberProcessed As Long
    Dim lngJobLength As Long
    Dim lngPageCounter As Long
    Dim lngViewedPage As Long
    
    Dim objFileSystem As New FileSystemObject
    Dim objFile As TextStream
    
    On Local Error GoTo errorHandler
    
    'get file name for saving text file
    With dlgResults
        .DialogTitle = "Export Results"
        .Filter = "Text Files (*.TXT)|*.txt"
        .Flags = cdlOFNPathMustExist + cdlOFNOverwritePrompt
        .FileName = ""
        .CancelError = True
        .ShowSave
    End With
    
    'Store current page being viewed
    lngViewedPage = lngCurrentPage
    'Save to a standard comma deliminated text file
    strTargetFile = dlgResults.FileName
    Me.MousePointer = vbHourglass
    
    'initialise progress display
    LoadProgressBar
    lngNumberProcessed = 0
    lngJobLength = lngPageLength * lngTotalPages
        
    'Open file
    Set objFile = objFileSystem.OpenTextFile(strTargetFile, ForWriting, True)
        'Export header
        grdResults.Row = 0
        
        For lngColCounter = 1 To grdResults.Cols - 1
            grdResults.Col = lngColCounter
            strLine = strLine + grdResults.Text + ","
        Next
        objFile.WriteLine strLine
        strLine = ""
        
        For lngPageCounter = 1 To lngTotalPages
            'Display each page, hiding the DisplayPage, progress bar, and then export it
            lngCurrentPage = lngPageCounter
            DisplayPage (True)
            
            For lngRowCounter = 1 To grdResults.Rows - 1
                grdResults.Row = lngRowCounter
                For lngColCounter = 1 To grdResults.Cols - 1
                    grdResults.Col = lngColCounter
                    
                    If grdResults.CellForeColor = vbRed Then
                        strLine = strLine + Str(Val(grdResults.Text) * -1) + ","
                    ElseIf grdResults.CellForeColor = vbBlue Then
                        strLine = strLine + Str(Val(grdResults.Text)) + ","
                    ElseIf Contains_carriage_return(grdResults.Text) Then
                        strLine = strLine + ReformatMultilineText(grdResults.Text, ";")
                    Else
                        strLine = strLine + grdResults.Text + ","
                    End If
                Next
                objFile.WriteLine strLine
                strLine = ""
                
                'indicate progress
                lngNumberProcessed = lngNumberProcessed + 1
                ShowProgress lngNumberProcessed, lngJobLength
            Next
        Next
    objFile.Close
    
    Me.MousePointer = vbDefault
    UnloadProgressBar
    
    'Reload page that was being viewed
    lngCurrentPage = lngViewedPage
    DisplayPage
    strMsg = "Results successfully exported to " + strTargetFile
    MsgBox strMsg, vbInformation, "Export Results"
            
Exit Sub
            
errorHandler:
    UnloadProgressBar
    If Err.Number = cdlCancel Then
        Exit Sub
    Else
        MsgBox Err.Description, vbExclamation, "Aborting"
        Exit Sub
    End If
Resume
End Sub

Private Sub LoadProgressBar()
    pnlProgress.Value = 0
    pnlProgress.Visible = True
    ResizeForm
End Sub

Private Sub UnloadProgressBar()
    pnlProgress.Visible = False
    ResizeForm
End Sub

Private Sub ShowProgress(lngNumberProcessed As Long, lngJobLength As Long)
    pnlProgress.Value = (lngNumberProcessed / lngJobLength) * 100
    pnlProgress.Refresh
End Sub

Private Sub mnuTools_Help_Click()
    cmdHelp.Value = True
End Sub

Private Sub mnuTools_AdjRowHeight_Click()
    'A handy utility to enable a user to adjust the height of several rows at once
    'Useful for multiline text
    
    Dim lngRowHeight As Long
    Dim strResponse As String
    Dim strMsg As String
    Dim lngRowCounter
    
    'Get row height using input box control
    strMsg = "Enter the number of rows to display. It should be between 1 and 20 inclusive."
    strResponse = InputBox(strMsg, "Adjust Row Height", "")
    
    'Validate the rowheight first
    If strResponse <> "" Then
        lngRowHeight = Val(strResponse)
        If lngRowHeight > 20 Then
            MsgBox "Entered value is too large.", vbExclamation, "Adjust Row Height"
        ElseIf lngRowHeight < 1 Then
            MsgBox "Entered value is too small.", vbExclamation, "Adjust Row Height"
        Else
            'Adjust the height of every row save for the header row
            For lngRowCounter = 1 To grdResults.Rows - 1
                grdResults.RowHeight(lngRowCounter) = 240 * lngRowHeight
            Next
        End If
    End If
    
End Sub
