VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmLevy_Charge_RunBatch 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Charge Students"
   ClientHeight    =   1395
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6975
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1395
   ScaleWidth      =   6975
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin MSComctlLib.ProgressBar ProgressBar 
      Height          =   360
      Left            =   120
      TabIndex        =   1
      Top             =   660
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   635
      _Version        =   393216
      BorderStyle     =   1
      Appearance      =   1
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Charging Student Accounts. Please wait"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   1230
      TabIndex        =   0
      Top             =   240
      Width           =   4515
   End
End
Attribute VB_Name = "frmLevy_Charge_RunBatch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Loading As Boolean

Private Sub Form_Activate()
    Dim strMsg As String
    Dim lngResponse As Long
    Dim rstCharge As Recordset
    
    Dim Class As String
    Dim strSQL As String
    
    'Intialise progress bar
    ProgressBar.Value = 0
    
    'obtain list of students in the selected class
    Class = Trim(frmLevy_Charge.cboClass.List(frmLevy_Charge.cboClass.ListIndex))
    strSQL = "SELECT  [Student ID]" _
            & "FROM  [Students] " _
            & "WHERE [Class] = '" & Class & "'"
    
    qryQueryObject.SQL = strSQL
    Set rstCharge = qryQueryObject.OpenRecordset
    
    'force immediate population recordset
    rstCharge.MoveLast
    rstCharge.MoveFirst
    
    If rstCharge.RecordCount = 0 Then
        strMsg = "The selected class does not contain any students."
        MsgBox strMsg, vbExclamation, "Batch Charge"
        Unload Me
    Else
        strMsg = "Are you sure you want to debit the accounts of the " _
               & Str(rstCharge.RecordCount) & " student(s) in " & Class & "?"
        lngResponse = MsgBox(strMsg, vbYesNo + vbQuestion, "Batch Charge")
        If lngResponse = vbYes Then
            Call DoCharge(rstCharge)
        End If
        Unload Me
    End If
    
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub DoCharge(rstCharge As Recordset)
    On Local Error GoTo errorHandler
    Dim lnglngPercent As Long
    Dim lngNumberProcessed As Long
    Dim lngFeeCounter As Long
    Dim varChargeArray() As Variant
    
    
    'Get Charge array
    varChargeArray = GetChargeArray
    
    'Do Charging
    rstCharge.MoveFirst
    Do
        For lngFeeCounter = 1 To UBound(varChargeArray, 2)
            rstLevyDebits.AddNew
                rstLevyDebits("Transaction Date") = Now
                rstLevyDebits("Fee Code") = varChargeArray(1, lngFeeCounter)
                rstLevyDebits("Amount") = varChargeArray(2, lngFeeCounter)
                rstLevyDebits("Student ID") = rstCharge("Student ID")
            rstLevyDebits.Update
        Next
        lngNumberProcessed = lngNumberProcessed + 1
        lnglngPercent = Int(lngNumberProcessed / rstCharge.RecordCount * 100)
        ProgressBar.Value = lnglngPercent
        Me.Refresh
        rstCharge.MoveNext
    Loop Until rstCharge.EOF
    
    MsgBox "Accounts successfully debited", vbInformation, "Batch Charge"

Exit Sub

errorHandler:
    MsgBox Err.Description, vbExclamation, "Error: No Charges Made"
    Unload Me
    
End Sub
