VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmSearch_Results 
   Caption         =   "Search Results"
   ClientHeight    =   4545
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   9555
   HelpContextID   =   710
   Icon            =   "Search Results.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4545
   ScaleWidth      =   9555
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox ButtonFrame 
      Align           =   2  'Align Bottom
      Height          =   675
      Left            =   0
      Negotiate       =   -1  'True
      ScaleHeight     =   615
      ScaleWidth      =   9495
      TabIndex        =   1
      Top             =   3870
      Width           =   9555
      Begin VB.CommandButton cmdClose 
         Cancel          =   -1  'True
         Caption         =   "Close"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   5048
         TabIndex        =   4
         Top             =   120
         Width           =   1215
      End
      Begin VB.CommandButton cmdPrint 
         Caption         =   "Print"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   788
         TabIndex        =   3
         Top             =   120
         Width           =   1215
      End
      Begin VB.CommandButton cmdHelp 
         Caption         =   "Help"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2948
         TabIndex        =   2
         Top             =   120
         Width           =   1215
      End
   End
   Begin MSComDlg.CommonDialog cdlgSearchResults 
      Left            =   6180
      Top             =   3780
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin MSFlexGridLib.MSFlexGrid grdResults 
      Height          =   3675
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7035
      _ExtentX        =   12409
      _ExtentY        =   6482
      _Version        =   393216
      Cols            =   7
      AllowUserResizing=   1
   End
   Begin VB.Menu mnuTools 
      Caption         =   "Tools"
      Begin VB.Menu mnuTools_ExportSourceSQL 
         Caption         =   "Export Source SQL"
      End
      Begin VB.Menu mnuTools_ExportToExcel 
         Caption         =   "Export To Excel"
      End
      Begin VB.Menu mnuTools_ExportToGenericFormat 
         Caption         =   "Export To Generic Format"
      End
      Begin VB.Menu mnuTools_Sep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Print 
         Caption         =   "Print"
      End
      Begin VB.Menu mnuTools_Sep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Help 
         Caption         =   "Help"
      End
      Begin VB.Menu mnuTools_Sep3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuTools_Close 
         Caption         =   "Close"
      End
   End
End
Attribute VB_Name = "frmSearch_Results"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Loading As Boolean
Private Const intCounterCol = 0
Private Const intStudentIDCol = 1
Private Const intSurnameCol = 2
Private Const intFirstNamesCol = 3
Private Const intClassCol = 4
Private Const intSexCol = 5
Private Const intGuardianSurname = 6


Private Sub cmdClose_Click()
    'Unload form from memory and display
    Unload Me
End Sub



Private Sub cmdHelp_Click()
    ShowHelpTopic 710
End Sub

Private Sub cmdPrint_Click()
    On Local Error GoTo Error_handler
    Dim lngRowCounter As Long
    Dim lngColCounter As Long
    
    'Get details of target printer
    With Me.cdlgSearchResults
        .PrinterDefault = True
        .CancelError = True
        .Flags = cdlPDHidePrintToFile
        .ShowPrinter
    End With
    
    'Initialise printer
    Printer.ScaleMode = vbCharacters
    Printer.Font.Name = "Courier"
    Printer.Font.Size = 12
    
    
    'Start by printing header
    Printer.CurrentY = 2
    PrintHeaderRow
    Printer.CurrentY = 5
    For lngRowCounter = 1 To grdResults.Rows - 1
        'If current line 3 rows from end of page then request new page and print a header
        If Printer.CurrentY >= Printer.ScaleHeight - 3 Then
            Printer.NewPage
            Printer.CurrentY = 2
            PrintHeaderRow
            Printer.CurrentY = Printer.CurrentY + 2
        End If
        
        'Print grid row
        grdResults.Row = lngRowCounter
        For lngColCounter = 1 To grdResults.Cols - 1
            grdResults.Col = lngColCounter
            Printer.CurrentX = getCurrentX(lngColCounter)
            Printer.Print grdResults.Text;
        Next
        
        'move to next line
        Printer.CurrentY = Printer.CurrentY + 1
    Next
    
    'commit print job
    Printer.EndDoc
    
    'confirm jon end
    MsgBox "Results successfully sent to the printer.", vbInformation, "Search"
    
Exit Sub

Error_handler:
    If Err.Number <> cdlCancel Then
        MsgBox Err.Description, vbExclamation, "Print"
    End If

End Sub

Private Sub PrintHeaderRow()
    Dim lngColCounter As Long
    Dim strMsg As String
    
    strMsg = "Search on " & FormatDateTime(Now, vbLongDate) & " @ " _
           & FormatDateTime(Now, vbLongTime) & " for " _
           & frmSearch_Master.cboSearchItem.List(frmSearch_Master.cboSearchItem.ListIndex) _
           & " = " & frmSearch_Master.txtSearchString.Text
           
    Printer.CurrentX = (Printer.ScaleWidth / 2) - (Printer.TextWidth(strMsg) / 2)
    Printer.Print strMsg
           
    grdResults.Row = 0
    For lngColCounter = 1 To grdResults.Cols - 1
        grdResults.Col = lngColCounter
        Printer.CurrentX = getCurrentX(lngColCounter)
        Printer.Print grdResults.Text;
    Next
    Printer.Print
    Printer.Line (0, Printer.CurrentY)-(Printer.ScaleWidth, Printer.CurrentY)
    Printer.Print
    
End Sub

Private Function getCurrentX(Column As Long) As Long
    'RETURNS the starting position of the passed column
    Dim lngReturnValue As Long
    
    Select Case Column
        Case 1
            lngReturnValue = 3
        Case 2
            lngReturnValue = 15
        Case 3
            lngReturnValue = 35
        Case 4
            lngReturnValue = 66
        Case 5
            lngReturnValue = 73
        Case 6
            lngReturnValue = 78
    End Select
    
    getCurrentX = lngReturnValue
    
End Function

Private Sub Form_Activate()
    Dim lngRowCounter As Long
    Dim OffSet, offset2 As Long
    
    If Loading Then
        Loading = False
        grdResults.Rows = rstSearchResults.RecordCount + 1
        'Set caption
        Me.Caption = "Search Results: " _
                   & frmSearch_Master.cboSearchItem.List(frmSearch_Master.cboSearchItem.ListIndex) _
                   & " = " & frmSearch_Master.txtSearchString.Text
                
        'initialise grid dimensions
        grdResults.ColWidth(intCounterCol) = 450
        grdResults.ColWidth(intStudentIDCol) = 1020
        grdResults.ColWidth(intSurnameCol) = 1695
        grdResults.ColWidth(intFirstNamesCol) = 2670
        grdResults.ColWidth(intClassCol) = 675
        grdResults.ColWidth(intSexCol) = 510
        grdResults.ColWidth(intGuardianSurname) = 2160
                       
        'Insert Header Text
        Call addDataToGrid("Student ID", 0, intStudentIDCol)
        Call addDataToGrid("Surname", 0, intSurnameCol)
        Call addDataToGrid("First Names", 0, intFirstNamesCol)
        Call addDataToGrid("Class", 0, intClassCol)
        Call addDataToGrid("Sex", 0, intSexCol)
        Call addDataToGrid("Guardian's Surname", 0, intGuardianSurname)
        
        'Column Alignments
        grdResults.ColAlignment(intCounterCol) = flexAlignRightCenter
        grdResults.ColAlignment(intStudentIDCol) = flexAlignLeftCenter
        grdResults.ColAlignment(intSurnameCol) = flexAlignLeftCenter
        grdResults.ColAlignment(intFirstNamesCol) = flexAlignLeftCenter
        grdResults.ColAlignment(intClassCol) = flexAlignCenterCenter
        grdResults.ColAlignment(intSexCol) = flexAlignCenterCenter
        grdResults.ColAlignment(intGuardianSurname) = flexAlignLeftCenter
        
        'Header Alignments
        grdResults.FixedAlignment(intCounterCol) = flexAlignRightCenter
        grdResults.FixedAlignment(intStudentIDCol) = flexAlignLeftCenter
        grdResults.FixedAlignment(intSurnameCol) = flexAlignLeftCenter
        grdResults.FixedAlignment(intFirstNamesCol) = flexAlignLeftCenter
        grdResults.FixedAlignment(intClassCol) = flexAlignCenterCenter
        grdResults.FixedAlignment(intSexCol) = flexAlignCenterCenter
        grdResults.FixedAlignment(intGuardianSurname) = flexAlignLeftCenter
        
        'Write search results to grid
        rstSearchResults.MoveFirst
        
        For lngRowCounter = 1 To rstSearchResults.RecordCount
            Call addDataToGrid(Str(lngRowCounter) & " ", lngRowCounter, intCounterCol)
            Call addDataToGrid(rstSearchResults("Student ID"), lngRowCounter, intStudentIDCol)
            Call addDataToGrid(rstSearchResults("Surname"), lngRowCounter, intSurnameCol)
            Call addDataToGrid(rstSearchResults("First Names"), lngRowCounter, intFirstNamesCol)
            Call addDataToGrid(rstSearchResults("Class"), lngRowCounter, intClassCol)
            Call addDataToGrid(rstSearchResults("Sex"), lngRowCounter, intSexCol)
            Call addDataToGrid(rstSearchResults("Guardian Surname"), lngRowCounter, intGuardianSurname)
            rstSearchResults.MoveNext
        Next
    End If
            
End Sub

Private Sub Form_Load()
    Loading = True
End Sub

Private Sub addDataToGrid(Text As String, Row As Long, Column As Long)
    
    grdResults.Row = Row
    grdResults.Col = Column
    grdResults.Text = Text

End Sub



Private Sub Form_Resize()
    Dim ButtonWidth As Long
    
    grdResults.Width = Me.ScaleWidth
    If Me.ScaleHeight - ButtonFrame.Height > 0 Then
        grdResults.Height = Me.ScaleHeight - ButtonFrame.Height
    End If
    
    ButtonWidth = cmdHelp.Width
    If ButtonFrame.ScaleWidth > 3 * ButtonWidth Then
        cmdPrint.Left = (ButtonFrame.ScaleWidth / 4) - (ButtonWidth / 2)
        cmdHelp.Left = (ButtonFrame.ScaleWidth / 2) - (ButtonWidth / 2)
        cmdClose.Left = (ButtonFrame.ScaleWidth / 4 * 3) - (ButtonWidth / 2)
    End If
End Sub

Private Sub mnuTools_Close_Click()
    cmdClose.Value = True
End Sub

Private Sub mnuTools_ExportSourceSQL_Click()
    ExportSourceSQL qryQueryObject.SQL
End Sub

Private Sub mnuTools_ExportToExcel_Click()
    Call ExportGridToExcel(Me, grdResults)
End Sub

Private Sub mnuTools_ExportToGenericFormat_Click()
    Call ExportGridToGeneric(Me, grdResults)
End Sub

Private Sub mnuTools_Help_Click()
    cmdHelp.Value = True
End Sub

Private Sub mnuTools_Print_Click()
    cmdPrint.Value = True
End Sub
