VERSION 5.00
Begin VB.Form frmAdminConsole_NewAdminPassword 
   Caption         =   "Set New Admin Password"
   ClientHeight    =   2310
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5910
   Icon            =   "Admin Console New Admin Password.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   2310
   ScaleWidth      =   5910
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtCurrentPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   2228
      PasswordChar    =   "*"
      TabIndex        =   0
      Top             =   180
      Width           =   3435
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2468
      TabIndex        =   6
      Top             =   1740
      Width           =   1155
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4268
      TabIndex        =   7
      Top             =   1740
      Width           =   1155
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   488
      TabIndex        =   5
      Top             =   1740
      Width           =   1155
   End
   Begin VB.TextBox txtReEnterPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   2228
      PasswordChar    =   "*"
      TabIndex        =   2
      Top             =   1140
      Width           =   3435
   End
   Begin VB.TextBox txtNewPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   2228
      PasswordChar    =   "*"
      TabIndex        =   1
      Top             =   660
      Width           =   3435
   End
   Begin VB.Label Label3 
      Caption         =   "Current Password"
      Height          =   255
      Left            =   248
      TabIndex        =   8
      Top             =   240
      Width           =   1935
   End
   Begin VB.Label Label2 
      Caption         =   "Re-enter Password"
      Height          =   255
      Left            =   248
      TabIndex        =   4
      Top             =   1200
      Width           =   1515
   End
   Begin VB.Label Label1 
      Caption         =   "New Password"
      Height          =   255
      Left            =   248
      TabIndex        =   3
      Top             =   720
      Width           =   1935
   End
End
Attribute VB_Name = "frmAdminConsole_NewAdminPassword"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**************************************************************************
'*                          Set New Admin Password                        *
'*   Modifies the registry entry for the adminstrative password           *
'**************************************************************************

Option Explicit

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdSave_Click()
    Dim strMsg As String
    Dim strAdminPassword As String
    
    strAdminPassword = Decrypt(GetSetting(regAppName, regSection, regKeyAdminPassword))
    
    If txtCurrentPassword = "" Then
        strMsg = "Please enter the current password"
        MsgBox strMsg, vbExclamation, "Change Password"
        txtCurrentPassword.SetFocus
    ElseIf txtCurrentPassword.Text <> strAdminPassword Then
        strMsg = "The entered current password is incorrect."
        MsgBox strMsg, vbExclamation, "Change Password"
        txtCurrentPassword.SetFocus
    ElseIf txtNewPassword.Text = "" Then
        strMsg = "Please enter the new password"
        MsgBox strMsg, vbExclamation, "Change Password"
        txtNewPassword.SetFocus
    ElseIf txtReEnterPassword.Text = "" Then
        strMsg = "Please reenter the new password in the space provided."
        MsgBox strMsg, vbExclamation, "Change Password"
        txtReEnterPassword.SetFocus
    ElseIf txtNewPassword.Text <> txtReEnterPassword.Text Then
        strMsg = "The entered new passwords do not match."
        MsgBox strMsg, vbExclamation, "Change Password"
        txtNewPassword.Text = ""
        txtReEnterPassword.Text = ""
        txtNewPassword.SetFocus
    Else
        SaveSetting regAppName, regSection, regKeyAdminPassword, Encrypt(txtNewPassword.Text)
        MsgBox "Password successfully changed.", vbInformation
        Unload Me
    End If
    
End Sub
