VERSION 5.00
Begin VB.Form frmSystem_ChangePassword 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Change User Password"
   ClientHeight    =   2805
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5970
   HelpContextID   =   340
   Icon            =   "System Change User Password.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2805
   ScaleWidth      =   5970
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox txtUserName 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   2228
      Locked          =   -1  'True
      TabIndex        =   9
      ToolTipText     =   "Enter username here"
      Top             =   180
      Width           =   3435
   End
   Begin VB.TextBox txtCurrentPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   2228
      PasswordChar    =   "*"
      TabIndex        =   0
      ToolTipText     =   "Enter the password you wish to change"
      Top             =   660
      Width           =   3435
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2468
      TabIndex        =   6
      ToolTipText     =   "Get assistance"
      Top             =   2220
      Width           =   1155
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4268
      TabIndex        =   7
      ToolTipText     =   "Close window without changing your password"
      Top             =   2220
      Width           =   1155
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   488
      TabIndex        =   5
      ToolTipText     =   "Click here to Change Password"
      Top             =   2220
      Width           =   1155
   End
   Begin VB.TextBox txtReEnterPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   2228
      MaxLength       =   30
      PasswordChar    =   "*"
      TabIndex        =   2
      ToolTipText     =   "Reenter your new password here."
      Top             =   1620
      Width           =   3435
   End
   Begin VB.TextBox txtNewPassword 
      Height          =   315
      IMEMode         =   3  'DISABLE
      Left            =   2228
      MaxLength       =   30
      PasswordChar    =   "*"
      TabIndex        =   1
      ToolTipText     =   "Enter the password you would like to change to."
      Top             =   1140
      Width           =   3435
   End
   Begin VB.Label Label4 
      Caption         =   "User Name"
      Height          =   255
      Left            =   255
      TabIndex        =   10
      Top             =   240
      Width           =   1935
   End
   Begin VB.Label Label3 
      Caption         =   "Current Password"
      Height          =   255
      Left            =   255
      TabIndex        =   8
      Top             =   720
      Width           =   1935
   End
   Begin VB.Label Label2 
      Caption         =   "Re-enter Password"
      Height          =   255
      Left            =   255
      TabIndex        =   4
      Top             =   1680
      Width           =   1515
   End
   Begin VB.Label Label1 
      Caption         =   "New Password"
      Height          =   255
      Left            =   255
      TabIndex        =   3
      Top             =   1200
      Width           =   1935
   End
End
Attribute VB_Name = "frmSystem_ChangePassword"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**************************************************************************
'*                          Set New User Password                         *
'*   Changes the password of the currently logged on user                 *
'**************************************************************************

Option Explicit

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub cmdHelp_Click()
    ShowHelpTopic 340
End Sub

Private Sub cmdSave_Click()
    On Local Error GoTo errorHandler
    
    Dim strMsg As String
    Dim strCurrentPassword As String
    
    strCurrentPassword = GetUserPassword(txtUserName.Text)
    
    If txtCurrentPassword = "" Then
        strMsg = "Please enter the current password"
        MsgBox strMsg, vbExclamation, "Change Password"
        txtCurrentPassword.SetFocus
    ElseIf txtCurrentPassword.Text <> strCurrentPassword Then
        strMsg = "The entered current password is incorrect."
        MsgBox strMsg, vbExclamation, "Change Password"
        txtCurrentPassword.Text = ""
        txtCurrentPassword.SetFocus
    ElseIf txtNewPassword.Text = "" Then
        strMsg = "Please enter the new password"
        MsgBox strMsg, vbExclamation, "Change Password"
        txtNewPassword.SetFocus
    ElseIf txtReEnterPassword.Text = "" Then
        strMsg = "Please reenter the new password in the space provided."
        MsgBox strMsg, vbExclamation, "Change Password"
        txtReEnterPassword.SetFocus
    ElseIf txtNewPassword.Text <> txtReEnterPassword.Text Then
        strMsg = "The entered new passwords do not match."
        MsgBox strMsg, vbExclamation, "Change Password"
        txtNewPassword.Text = ""
        txtReEnterPassword.Text = ""
        txtNewPassword.SetFocus
    Else
        Call SetUserPassword(txtUserName.Text, txtNewPassword.Text)
        MsgBox "Password successfully changed.", vbInformation, "Change Password"
        Unload Me
    End If

Exit Sub

errorHandler:
    If Err.Number = errUserNotFound Then
        strMsg = "Unable to locate your user account. Please try logging off and logging " _
               & "back on again."
        MsgBox strMsg, vbCritical, "System Error"
    Else
        MsgBox Err.Description, vbExclamation, "Password Not Changed"
    End If
    
End Sub

Private Sub Form_Load()
    txtUserName.Text = CurrentUser.UserName
End Sub
